#include <cstdlib>
#include <map>

#include <iostream>
#include <vector>
#include <array>
#include <fstream>

//#include "newtonsolver.hh"
//#include "testfunction.hh"
#include "newton_exception.hh"

/**
 * Executes the simulation.
 */
int main (int argc, char** argv)
{
  try
  {
    // a map for collecting the options
    std::map<std::string,std::string> options;
    options["eps"] = "1e-10"; // 

    // parse command line parameters
    for (int i = 1; i < argc; i++)
    {
      std::string key = argv[i];
      std::string::size_type sub = key.find("=");
      if (sub == std::string::npos)
        throw Newton_Exception("Failed to parse option " + key);
      std::string val = key.substr(sub+1);
      key.erase(sub);
      options[key] = val;
    }

    // read final parameters
    double eps = atof(options["eps"].c_str());
    
    // vector and matrix type
    typedef std::array<double,2> Vector;
    typedef std::array<Vector,2> Matrix;

    // starting point for the newton solver iteration
    Vector z;
    
    //TODO: Solve for zeros of the Schnakenberg function
    //      this could look like this:
    
    // NewtonSolver<Vector, Matrix> solver(eps);
    // TestFunction<Vector, Matrix, double> f();
      
    // solver.apply(f,z);
    // std::cout <<"Nullstelle: " << z[0] << "  " << z[1] << std::endl;


  // exit without an error
  return 0;
  }
  catch (std::exception& e)
  {
    std::cout << "ERROR: " << e.what() << std::endl;
  }
}
