#ifndef NEWTON_EXCEPTION_HH
#define NEWTON_EXCEPTION_HH

#include <exception>
#include <string>


/**
 * An exception class for exceptions which are
 * related to our newton solver code.
 */
class Newton_Exception
  : public std::exception
{
public:
  Newton_Exception (const std::string& msg) noexcept
    : msg_(msg)
  {}

  virtual ~Newton_Exception () throw() {}

  virtual const char* what () const noexcept
  {
    return msg_.c_str();
  }

private:
  std::string msg_;
};


#endif // NEWTON_EXCEPTION_HH
